* Program: SysTest.PRG
*  Notice: Placed in the Public Domain on August 4, 1993.
*  Author: Tom Rettig
*        : Rettig Micro Corporation
*        : 2532 Lincoln Boulevard, Suite 110
*        : Marina del Rey, CA  90291-5978
*        :  Telephone: 310-301-0911
*        :        FAX: 310-821-1162
*        : CompuServe: 75066,352
*        :           : in FOXUSER 3rd-Party section or MAIL
*  Update: Version 1.00 -- August 4, 1993
*        : Version 1.01 -- September 1, 1993
*        : Version 1.02 -- December 1, 1993
*        : Version 1.10 -- July 8, 1994
*        : Version 2.00 -- July 15, 1995
*  Action: For testing system configuration limits in FoxPro
*        :    on all platforms where FoxPro runs.
*  Syntax: DO SysTest [WITH <cMethod> [, <cOutputFileName>]]
*        : <method> = "SYS" | "SET" | "ON" | "MIS" | "VAR" |
*        :            "FILE" | "CONFIG" | "GRAPHIC" | "FONT"
*        :            Default <method> is all of the methods
*Requires: Visual FoxPro or FoxPro version 2.5 or greater
*        :    for DOS, Windows, Macintosh, or UNIX.
*   Notes: - May be freely used, modified, and distributed in
*        : compiled and/or source code form.
*        : - The author appreciates acknowledgment in commercial
*        : products and publications that use or learn from this program.
*        : - Technical support is not officially provided.  The
*        : author is very interested in hearing about problems
*        : or enhancement requests you have, and will try to be
*        : helpful within reasonable limits.  Email or fax preferred.
*        : - Warranty Disclaimer: NO WARRANTY!!!
*        : THE AUTHOR RELEASES TO THE PUBLIC DOMAIN ALL CLAIMS TO ANY
*        : RIGHTS IN THIS PROGRAM AND FREELY PROVIDES IT AS IS WITHOUT
*        : WARRANTY OF ANY KIND, EXPRESSED OR IMPLIED, INCLUDING, BUT NOT
*        : LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
*        : FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL THE AUTHOR, OR ANY
*        : OTHER PARTY WHO MAY MODIFY AND/OR REDISTRIBUTE THIS PROGRAM, BE
*        : LIABLE FOR ANY COMMERCIAL, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
*        : DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM
*        : INCLUDING, BUT NOT LIMITED TO, LOSS OF DATA OR DATA BEING
*        : RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR LOSSES
*        : SUSTAINED BY THIRD PARTIES OR A FAILURE OF THE PROGRAM TO
*        : OPERATE WITH ANY OTHER PROGRAMS, EVEN IF YOU OR OTHER PARTIES
*        : HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

* Preprocessor directives.
#DEFINE ccSYSTESTVERS    "2.00"
#DEFINE ccBOOTDRIVE      "C:"
#DEFINE ccEQUALS         " == "
#DEFINE cnMAXFILESOPEN    255
#DEFINE cnMAXSYSFUNC     4000
#DEFINE cnMAXSYSMETRIC     34
#DEFINE ccMESSAGEWRITE   "*** " + ccMESSAGE + ": ***"
#DEFINE ccMSGSTART       "*** SysTest version", ccSYSTESTVERS,;
                         "on", DATE(), "at", TIME(), "***"
#DEFINE ccMSGENDFILE     "*** Testing Complete ***"
#DEFINE ccMSGENDWAIT     "Test complete and results written to "
#DEFINE ccMSGNOOPEN      "Cannot open file."
#DEFINE ccMSGNOFIND      "Cannot find file."
#DEFINE ccMSGFILEOPEN    "Files Open: "
#DEFINE ccMSGFILEERROR   "Error Opening: "
#DEFINE ccMSGFILEREPORT  "Error Reported: "
#DEFINE ccMSGFILECLOSE   "Closing Open Files"
#DEFINE ccMSGFILEHANDLES "No more available OS file handles"
#DEFINE cnPADRLEN        IIF(" 03." $ VERSION(), 40, 30)
#DEFINE ccOUTPUTFILE     IIF(_UNIX, "systest.txt", "SysTest.TXT")
* Skipped sys numbers are currently limited to 24, the max of INLIST().
#DEFINE ccSKIPSYSFUNC    3,998,999,1020,1021,1022,1037,;
                         2002,2008,2009,2013,2015,2017,2027,;
                         3005,3006,3050,3052

* Begin code.
PARAMETERS T__Method, T__File
RELEASE ALL EXCEPT T__*
PRIVATE ALL LIKE T__*

* Set up.
SET TALK OFF
CLOSE ALL
SET SAFETY OFF
SET ALTERNATE TO (IIF(EMPTY(T__File), ccOUTPUTFILE, T__File))
SET ALTERNATE ON
SET SAFETY ON
SET EXACT OFF
ON ERROR STORE .T. TO T__IsError
T__IsVisual = NOT " 2." $ VERSION()
T__OutputFile = SET("ALTERNATE", 1)

IF _DOS OR _UNIX  && character platforms
   DEFINE WINDOW T__win FROM 0,0 TO 5,5;
      TITLE T__OutputFile CLOSE FLOAT SYSTEM COLOR SCHEME 8
ELSE              && graphical platforms _WINDOWS and _MAC
   DEFINE WINDOW T__win FROM 0,0 TO 5,5;
      TITLE T__OutputFile CLOSE FLOAT SYSTEM ZOOM GROW
ENDIF
IF " 03.00" $ VERSION()  && VFP bug prevents zooming while inactive
   ACTIVATE WINDOW T__win
ENDIF
ZOOM WINDOW T__win MAX
ACTIVATE WINDOW T__win
?? ccMSGSTART

* SYS() functions.
STORE .F. TO T__IsError, T__IsFoxHelp
IF EMPTY(m.T__Method) OR UPPER(m.T__Method)="SYS"
   #DEFINE ccMESSAGE "Testing SYS() Functions"
   WAIT WINDOW NOWAIT ccMESSAGE
   ?
   ? ccMESSAGEWRITE
   DECLARE T__SysTopics[1]
   T__SysTopics = ""
   SET HELP OFF
   SELECT FoxHelp.Topic;
      FROM (SYS(2004)+"FoxHelp.dbf");
      INTO ARRAY T__SysTopics;
      WHERE FoxHelp.Topic = "SYS("
   IF USED("FoxHelp")
      T__IsFoxHelp = .T.
      USE IN FoxHelp
   ENDIF
   SET HELP ON
   FOR T__i = 0 TO cnMAXSYSFUNC
      IF INLIST(m.T__i, ccSKIPSYSFUNC)
         LOOP
      ENDIF
      T__IsError = .F.
      IF NOT EMPTY(SYS(m.T__i))
         IF NOT m.T__IsError
            T__scan = ASCAN(T__SysTopics,;
                            "SYS("+LTRIM(STR(m.T__i))+") ")
            ? "SYS(" + STR(m.T__i,4) + ") " +;
              PADR(IIF(m.T__scan==0,;
                      IIF(m.T__IsFoxHelp, "Undocumented", ""),;
                      ALLTRIM(SUBSTR(T__SysTopics[T__scan],;
                              IIF(T__IsVisual,;
                                  AT(" - ",T__SysTopics[T__scan])+3,;
                                  AT(" ",T__SysTopics[T__scan]))))),;
                      cnPADRLEN)+;
              ccEQUALS + SYS(m.T__i)
         ENDIF
      ENDIF
   ENDFOR
   RELEASE T__scan, T__SysTopics, T__i
   #UNDEF ccMESSAGE
ENDIF

* Open Systest.dbf and filter on current platform for SET(),
* ON(), system variables, and miscellaneous functions.
USE (LOCFILE("SysTest.dbf", "dbf",;
             IIF("Windows 4." $ OS(),;
                 "Systest.dbf",;
                 "Where is SysTest.dbf?")));
    NOUPDATE
DO CASE
   CASE T__IsVisual
      DO CASE
         CASE _WINDOWS
            SET FILTER TO Is_Win3
         CASE _MAC
            SET FILTER TO Is_Mac3
         CASE _DOS
            SET FILTER TO Is_DOS3
      ENDCASE
   CASE _DOS
      SET FILTER TO Is_DOS2
   CASE _WINDOWS
      SET FILTER TO Is_Win2
   CASE _MAC
      SET FILTER TO Is_Mac2
   CASE _UNIX
      SET FILTER TO Is_UNIX2
ENDCASE
T__TempIdx = SYS(3)+".idx"
SET SAFETY OFF
INDEX ON Class+Keyword TO (m.T__TempIdx)
SET SAFETY ON

* SET() functions.
T__IsError = .F.
IF (EMPTY(m.T__Method) OR UPPER(m.T__Method)="SET");
      AND USED("SysTest")
   #DEFINE ccMESSAGE "Testing SET() Functions"
   WAIT WINDOW NOWAIT ccMESSAGE
   ?
   ? ccMESSAGEWRITE
   SCAN FOR Class="SET"
      ? PADR("SET("+TRIM(Keyword)+")", cnPADRLEN)+;
        ccEQUALS, SET(TRIM(Keyword))
      IF Is_Option
         ? PADR("SET("+TRIM(Keyword)+",1)", cnPADRLEN)+;
           ccEQUALS, SET(TRIM(Keyword),1)
      ENDIF
   ENDSCAN
   #UNDEF ccMESSAGE
ENDIF

* ON() functions.
T__IsError = .F.
IF (EMPTY(m.T__Method) OR UPPER(m.T__Method)="ON");
      AND USED("SysTest")
   #DEFINE ccMESSAGE "Testing ON() Functions"
   WAIT WINDOW NOWAIT ccMESSAGE
   ?
   ? ccMESSAGEWRITE
   SCAN FOR Class="ON"
      ? PADR("ON("+TRIM(Keyword)+")", cnPADRLEN)+;
        ccEQUALS, ON(TRIM(Keyword))
   ENDSCAN
   #UNDEF ccMESSAGE
ENDIF

* Miscellaneous configuration functions.
T__IsError = .F.
IF (EMPTY(m.T__Method) OR UPPER(m.T__Method)="MIS");
      AND USED("SysTest")
   #DEFINE ccMESSAGE "Testing Miscellaneous Functions"
   WAIT WINDOW NOWAIT ccMESSAGE
   ?
   ? ccMESSAGEWRITE
   SCAN FOR Class="MIS"
      ? PADR(TRIM(Keyword), cnPADRLEN)+;
        ccEQUALS, EVALUATE(TRIM(Keyword))
   ENDSCAN
   #UNDEF ccMESSAGE
ENDIF

* System memory variables.
T__IsError = .F.
IF (EMPTY(m.T__Method) OR UPPER(m.T__Method)="VAR");
      AND USED("SysTest")
   #DEFINE ccMESSAGE "Testing System Memory Variables"
   WAIT WINDOW NOWAIT ccMESSAGE
   ?
   ? ccMESSAGEWRITE
   SCAN FOR Class="VAR"
      ? PADR(TRIM(Keyword), cnPADRLEN)+;
        ccEQUALS, EVALUATE(TRIM(Keyword))
   ENDSCAN
   #UNDEF ccMESSAGE
ENDIF

USE IN SysTest
ERASE (m.T__TempIdx)

* SYSMETRIC() and WFONT() functions.
T__IsError = .F.
IF (EMPTY(m.T__Method) OR UPPER(m.T__Method)="GRAPHIC") AND;
   (_WINDOWS OR _MAC)
   #DEFINE ccMESSAGE "Testing SYSMETRIC() Functions"
   WAIT WINDOW NOWAIT ccMESSAGE
   ?
   ? ccMESSAGEWRITE
   DECLARE T_help[1]
   T_help = ""
   SET HELP OFF
   SELECT FoxHelp.Details;
      FROM (SYS(2004)+"FoxHelp.dbf");
      INTO ARRAY T_help;
      WHERE FoxHelp.Topic = "SYSMETRIC("
   IF USED("FoxHelp")
      USE IN FoxHelp
   ENDIF
   SET HELP ON
   T_help[1] = STRTRAN(T_help[1], CHR(9), " ")
   DECLARE T__array[cnMAXSYSMETRIC]
   T__array = ""
   STORE 0 TO _MLINE, T__len
   FOR T__i = 1 TO MEMLINES(T_help[1])
      T__string = ALLTRIM(MLINE(T_help[1], 1, _MLINE))
      IF VAL(m.T__string)>0
         T__array[VAL(m.T__string)] =;
            LTRIM(SUBSTR(m.T__string, AT(" ", m.T__string)))
         IF LEN(T__array[VAL(m.T__string)])>m.T__len
            T__len = LEN(T__array[VAL(m.T__string)])
         ENDIF
      ENDIF
   ENDFOR
   IF m.T__len==0
      T__len = 8
   ENDIF
   FOR T__i = 1 TO cnMAXSYSMETRIC
      ? "SYSMETRIC(" + STR(m.T__i,2) + ") " +;
        PADR(T__array[m.T__i], m.T__len)+;
        ccEQUALS + STR(SYSMETRIC(m.T__i),4)
   ENDFOR
   #UNDEF ccMESSAGE
   #DEFINE ccMESSAGE "Testing WFONT() Functions"
   WAIT WINDOW NOWAIT ccMESSAGE
   ?
   ? ccMESSAGEWRITE
   FOR T__i = 1 TO 3
      ? PADR("WFONT("+STR(m.T__i,1)+', "")', cnPADRLEN)+;
        ccEQUALS, WFONT(m.T__i, "")
   ENDFOR
   RELEASE T__i, T_help, T__string, T__array, T__len
   #UNDEF ccMESSAGE
ENDIF

* Available fonts and sizes.
T__IsError = .F.
IF (EMPTY(m.T__Method) OR UPPER(m.T__Method)="FONT") AND;
      (_WINDOWS OR _MAC)
   #DEFINE ccMESSAGE "Testing Available Fonts"
   WAIT WINDOW NOWAIT ccMESSAGE
   ?
   ? ccMESSAGEWRITE
   =AFONT(T__fonts)
   FOR T__i = 1 TO ALEN(T__fonts)
      T__string = T__fonts[m.T__i] + ": "
      IF AFONT(T__sizes, T__fonts[m.T__i])
         FOR T__j = 1 TO ALEN(T__sizes)
            T__string = m.T__string+;
               IIF(m.T__j==1, "", ", ")+;
               IIF(T__sizes[m.T__j]==-1,;
                   "scalable", LTRIM(STR(T__sizes[m.T__j])))
         ENDFOR
      ENDIF
      ? m.T__string
   ENDFOR
   RELEASE T__i, T__j, T__fonts, T__sizes, T__string
   #UNDEF ccMESSAGE
ENDIF

* File contents of Config.fp? and OS configuration files.
T__IsError = .F.
IF (EMPTY(m.T__Method) OR UPPER(m.T__Method)="CONFIG")
   FOR T__i = 1 TO 3
      DO CASE
         CASE m.T__i==1
            T__file = SYS(2019)
            IF EMPTY(m.T__file)
               IF _UNIX
                  T__file = "config.fpu"
               ELSE
                  T__file = SYS(2004)+"CONFIG.FP"+;
                     IIF(_WINDOWS, "W", IIF(_MAC, "M", ""))
               ENDIF
            ENDIF
         CASE m.T__i==2
            DO CASE
               CASE _MAC  && test only Config.fpm
                  EXIT
               CASE _UNIX
                  * Files beginning with a dot (.) cannot be
                  * opened, so copy to temp file and open it.
                  RUN cp $HOME/.profile /tmp/profile.tmp
                  *///Pipe thru SED to add CR?
                  T__file = "/tmp/profile.tmp"
               OTHERWISE  && dos or windows
                  T__file = ccBOOTDRIVE + "\CONFIG.SYS"
            ENDCASE
         CASE m.T__i==3
            DO CASE
               CASE _UNIX
                  * Files beginning with a dot (.) cannot be
                  * opened, so copy to temp file and open it.
                  RUN cp $ENV /tmp/shell.tmp
                  *///Pipe thru SED to add CR?
                  T__file = "/tmp/shell.tmp"
               OTHERWISE  && dos or windows
                  T__file = ccBOOTDRIVE + "\AUTOEXEC.BAT"
            ENDCASE
      ENDCASE
      * IIF is for 2.5 compatibility without SYS(2027).
      #DEFINE ccMESSAGE "Testing File "+;
                       IIF(_MAC OR _UNIX,;
                           SYS(2027,m.T__file), m.T__file)
      WAIT WINDOW NOWAIT ccMESSAGE
      ?
      ? ccMESSAGEWRITE
      IF FILE(m.T__file)
         T__handle = FOPEN(m.T__file)
         IF m.T__handle>-1
            DO WHILE NOT FEOF(m.T__handle)
               ? FGETS(m.T__handle)
            ENDDO
            =FCLOSE(m.T__handle)
            IF _UNIX AND m.T_i>1
               * Remove temp files used to read
               * profile and shell.
               ERASE (m.T__file)
            ENDIF
         ELSE
            ? ccMSGNOOPEN
         ENDIF
      ELSE
         ? ccMSGNOFIND
      ENDIF
   ENDFOR

   * Run OS-specific utilities.
   DO CASE
      CASE _UNIX  && read vmstat output
         T__file = "/tmp/vmstat.tmp"
         WAIT WINDOW NOWAIT ccMESSAGE
         ?
         ? ccMESSAGEWRITE
         RUN vmstat -s > &T__file
         T__handle = FOPEN(m.T__file)
         IF m.T__handle>-1
            DO WHILE NOT FEOF(m.T__handle)
               ? FGETS(m.T__handle)
            ENDDO
            =FCLOSE(m.T__handle)
            ERASE (m.T__file)
         ELSE
            ? ccMSGNOOPEN
         ENDIF
   ENDCASE
   RELEASE T__file, T__handle, T__i
   #UNDEF ccMESSAGE
ENDIF

* File opening.
T__IsError = .F.
IF EMPTY(m.T__Method) OR UPPER(m.T__Method)="FILE"
   #DEFINE ccMESSAGE "Testing Open Files"
   WAIT WINDOW NOWAIT ccMESSAGE
   ?
   ? ccMESSAGEWRITE
   ?
   * The open Alternate file counts as one file, and this
   * compiled program may count as one file because it's
   * already open when run right after the prg is modified.
   T__offset = FOPEN(PROGRAM()+".FXP", 11)
   IF m.T__offset==-1
      T__offset = 2
   ELSE
      =FCLOSE(m.T__offset)
      T__offset = 1
   ENDIF

   T__ErrorNo  = 0
   T__ErrorMsg = ""
   SET SAFETY OFF
   DECLARE T__files[cnMAXFILESOPEN]
   FOR T__i = 1 TO cnMAXFILESOPEN
      T__files[m.T__i] = SYS(3)
      CREATE TABLE (T__files[m.T__i]) (Temp C(1))
      IF m.T__IsError
         T__ErrorNo  = LTRIM(STR(ERROR()))
         T__ErrorMsg = IIF(ERROR()==0,;
                           ccMSGFILEHANDLES, TRIM(MESSAGE(1)))
         EXIT
      ELSE
         @ ROW(), 0 SAY ccMSGFILEOPEN+;
                        STR(m.T__i+m.T__offset, 3)
      ENDIF
   ENDFOR
   SET SAFETY ON
   @ ROW(), 0 SAY ""
   ?? ccMSGFILEOPEN   + STR(m.T__i-1+m.T__offset, 3), " ",;
      ccMSGFILEERROR  + STR(m.T__i+m.T__offset, 3)
   ?  ccMSGFILEREPORT + T__ErrorNo, T__ErrorMsg
   WAIT WINDOW NOWAIT ccMSGFILECLOSE
   FOR T__i = 1 TO cnMAXFILESOPEN
      IF EMPTY(T__files[m.T__i])
         EXIT
      ENDIF
      USE IN (m.T__i)
      IF FILE(T__files[m.T__i]+".DBF")
         ERASE (T__files[m.T__i]+".DBF")
      ENDIF
   ENDFOR
   RELEASE T__offset, T__files, T__i, T__ErrorNo, T__ErrorMsg
   #UNDEF ccMESSAGE
ENDIF

* Close alternate file and remove end-of-file marker CHR(26).
SET CONSOLE OFF
?
? ccMSGENDFILE
SET CONSOLE ON
ON ERROR
CLOSE ALL
T__handle = FOPEN(T__OutputFile, 2)
IF NOT m.T__handle==-1
   =FSEEK(m.T__handle, -1, 2)
   IF FREAD(m.T__handle,1)==CHR(26)
      =FCHSIZE(m.T__handle, FSEEK(m.T__handle, -1, 2))
   ENDIF
   =FCLOSE(m.T__handle)
ENDIF

* Clean up and exit.
ACTIVATE SCREEN
SET TALK ON
WAIT WINDOW NOWAIT ccMSGENDWAIT + T__OutputFile
MODIFY COMMAND (T__OutputFile) NOEDIT WINDOW T__win
RELEASE WINDOW T__win
RETURN
*** SysTest.prg *********************************************
